/*
``Copyright (C) 1996 Kenzo KONISHI and Kazuo TAKI in Kobe University''
*/

/*******************************************************************
*	BDD$B=hM}7O$N%G%P%0%3!<%I$N%^%/%mDj5A72(B
*******************************************************************/

/*>>>>>>>>>>>>>>>>> DEBUG > 1 <<<<<<<<<<<<<<<<<<*/
#if DEBUG > 1

#ifdef __STDC__
extern void set_node_t(node_t *);
extern void check_node_t(node_t *, int, char *);
extern void set_ope_cache_t(ope_cache_t *);
extern void check_ope_cache_t(ope_cache_t *, int, char *);
extern void set_val_tbl_t(val_tbl_t *);
extern void check_val_tbl_t(val_tbl_t *, int, char *);
extern void set_output_node_t(output_node_t *);
extern void check_output_node_t(output_node_t *, int, char *);
extern void set_sort_tbl_t(sort_tbl_t *);
extern void check_sort_tbl_t(sort_tbl_t *, int, char *);
extern void set_edge_t(edge_t *);
extern void check_edge_t(edge_t *, int, char *);
#else
extern void set_node_t(/* node_t * */);
extern void check_node_t(/* node_t *, int, char * */);
extern void set_ope_cache_t(/* ope_cache_t * */);
extern void check_ope_cache_t(/* ope_cache_t *, int, char * */);
extern void set_val_tbl_t(/* val_tbl_t * */);
extern void check_val_tbl_t(/* val_tbl_t *, int, char * */);
extern void set_output_node_t(/* output_node_t * */);
extern void check_output_node_t(/* output_node_t *, int, char * */);
extern void set_sort_tbl_t(/* sort_tbl_t * */);
extern void check_sort_tbl_t(/* sort_tbl_t *, int, char * */);
extern void set_edge_t(/* edge_t * */);
extern void check_edge_t(/* edge_t *, int, char * */);
#endif /* __STDC__ */

#define SET_NODE_T(pt)			set_node_t(pt)
#define CHECK_NODE_T(pt)		check_node_t((pt), __LINE__, __FILE__)
#define SET_OPE_CACHE_T(pt)		set_ope_cache_t(pt)
#define CHECK_OPE_CACHE_T(pt)	check_ope_cache_t(pt, __LINE__, __FILE__)
#define SET_VAL_TBL_T(pt)		set_val_tbl_t(pt)
#define CHECK_VAL_TBL_T(pt)		check_val_tbl_t(pt, __LINE__, __FILE__)
#define SET_OUTPUT_NODE_T(pt)	set_output_node_t(pt)
#define CHECK_OUTPUT_NODE_T(pt)	check_output_node_t(pt, __LINE__, __FILE__)
#define SET_SORT_TBL_T(pt)		set_sort_tbl_t(pt)
#define CHECK_SORT_TBL_T(pt)	check_sort_tbl_t(pt, __LINE__, __FILE__)
#define	SET_EDGE_T(pt)		set_edge_t(pt)
#define CHECK_EDGE_T(pt)	check_edge_t(pt, __LINE__, __FILE__)

#else

#define SET_NODE_T(pt)			
#define CHECK_NODE_T(pt)		
#define SET_OPE_CACHE_T(pt)		
#define CHECK_OPE_CACHE_T(pt)	
#define SET_VAL_TBL_T(pt)		
#define CHECK_VAL_TBL_T(pt)		
#define SET_OUTPUT_NODE_T(pt)	
#define CHECK_OUTPUT_NODE_T(pt)	
#define SET_SORT_TBL_T(pt)
#define CHECK_SORT_TBL_T(pt)
#define	SET_EDGE_T(pt)		
#define CHECK_EDGE_T(pt)	

#endif /* DEBUG > 1 */

/*>>>>>>>>>>>>>>>>> DEBUG > 2 <<<<<<<<<<<<<<<<<<*/

#if DEBUG > 2

#ifdef __STDC__
extern void check_shannon_edge(int, char *);
extern void check_shared_node(int, char *);
extern void check_ref_ct(int, char *);
extern void final_check_ref_ct(int, char *);
extern void print_hash_image(int, char *);
extern void print_hash_image_each_level(int, int, char *);
extern void print_ope_cache(int, char *);
extern void all_print_node_tbl(int, char *);
extern void print_free_list(int, char *);
extern void edge_check(int, char *);
extern void check_hash_node_num(int, char *);
extern void set_debug_ref_ct_zero(node_t *);
extern void check_ref_ct_on_each_node(int, char *);
extern void print_ref_ct_info(int, char *);
extern void check_level_in_hash_tbl(int, char *);
extern void check_same_node_in_hash_tbl(int, char *);
extern void check_complement(int, char *);
extern void check_swap_pattern(int, char *);
#else
extern void check_shannon_edge(/* int, char * */);
extern void check_shared_node(/* int, char * */);
extern void check_ref_ct(/* int, char * */);
extern void final_check_ref_ct(/* int, char * */);
extern void print_hash_image(/* int, char * */);
extern void print_hash_image_each_level(/* int, int, char * */);
extern void print_ope_cache(/* int, char * */);
extern void all_print_node_tbl(/* int, char * */);
extern void print_free_list(/* int, char * */);
extern void edge_check(/* int, char * */);
extern void check_hash_node_num(/* int, char * */);
extern void set_debug_ref_ct_zero(/* node_t * */);
extern void check_ref_ct_on_each_node(/* int, char * */);
extern void print_ref_ct_info(/* int, char * */);
extern void check_level_in_hash_tbl(/* int, char * */);
extern void check_same_node_in_hash_tbl(/* int, char * */);
extern void check_complement(/* int, char * */);
extern void check_swap_pattern(/* int, char * */);
#endif /* __STDC__ */								  

#define CHECK_SHANNON_EDGE		check_shannon_edge(__LINE__, __FILE__)
#define CHECK_SHARED_NODE		check_shared_node(__LINE__, __FILE__)
#define CHECK_REF_CT			check_ref_ct(__LINE__, __FILE__)
#define FINAL_CHECK_REF_CT		final_check_ref_ct(__LINE__, __FILE__)
#define PRINT_HASH_IMAGE		print_hash_image(__LINE__, __FILE__)
#define PRINT_HASH_IMAGE_EACH_LEVEL(level)		print_hash_image_each_level((level), __LINE__, __FILE__)
#define PRINT_OPE_CACHE			print_ope_cache(__LINE__, __FILE__)
#define ALL_PRINT_NODE_TBL		all_print_node_tbl(__LINE__, __FILE__)
#define FREE_LIST_PRINT			print_free_list(__LINE__, __FILE__)
#define EDGE_CHECK				edge_check(__LINE__, __FILE__)
#define CHECK_HASH_NODE_NUM		check_hash_node_num(__LINE__, __FILE__)
#define SET_DEBUG_REF_CT_ZERO(pt)	set_debug_ref_ct_zero(pt)
#define CHECK_REF_CT_ON_EACH_NODE	 check_ref_ct_on_each_node(__LINE__, __FILE__)
#define PRINT_REF_CT_INFO		print_ref_ct_info(__LINE__, __FILE__)
#define CHECK_LEVEL_IN_HASH_TBL	check_level_in_hash_tbl(__LINE__, __FILE__)
#define CHECK_SAME_NODE_IN_HASH_TBL	check_same_node_in_hash_tbl(__LINE__, __FILE__)
#define CHECK_COMPLEMENT			check_complement(__LINE__, __FILE__);
#define CHECK_SWAP_PATTERN			check_swap_pattern(__LINE__, __FILE__);

#else

#define CHECK_SHANNON_EDGE
#define CHECK_SHARED_NODE
#define CHECK_REF_CT
#define LAST_CHECK_REF_CT
#define FINAL_CHECK_REF_CT
#define PRINT_HASH_IMAGE 
#define PRINT_HASH_IMAGE_EACH_LEVEL(level)
#define PRINT_OPE_CACHE
#define ALL_PRINT_NODE_TBL
#define FREE_LIST_PRINT
#define EDGE_CHECK
#define CHECK_HASH_NODE_NUM
#define SET_DEBUG_REF_CT_ZERO(pt)
#define CHECK_REF_CT_ON_EACH_NODE
#define PRINT_REF_CT_INFO
#define CHECK_LEVEL_IN_HASH_TBL	
#define CHECK_SAME_NODE_IN_HASH_TBL
#define CHECK_COMPLEMENT
#define CHECK_SWAP_PATTERN

#endif /* DEBUG > 2 */


/*>>>>>>>>>>>>>>>>> DEBUG > 3 <<<<<<<<<<<<<<<<<<*/

#if DEBUG > 3

#ifdef __STDC__
extern void print_input_val(int, char *);
#else
extern void print_input_val(/* int, char * */);
#endif /* __STDC__ */

#define PRINT_INPUT_VAL		print_input_val(__LINE__, __FILE__)

#else

#define PRINT_INPUT_VAL

#endif /* DEBUG > 3 */


/*
 *
 * $B0J9_$N#1#0?t9T$K4X$9$k@bL@$r=q$/$?$a$NCf%l%Y%k$N%3%a%s%H(B
 *
 *
 *
 */

#if VERBOSE > 2

#define ENTER(str)	fprintf(stderr, "ENTER the function : %s\n", str);
#define EXIT(str)	fprintf(stderr, "EXIT the function : %s\n", str);

#else

#define ENTER(str)
#define EXIT(str)

#endif /* VERBOSE > 2 */

