/*
``Copyright (C) 1996 Kenzo KONISHI and Kazuo TAKI in Kobe University''
*/

/*******************************************************************
*	1996$BG/(B2$B7n(B1$BF|@=:n3+;O(B
*	FBDD$B$N(Btype$B$r:n$k$?$a$N%W%m%0%i%`(B
*	debug macro$BIt(B
*	by KANADA.T
*******************************************************************/

#if DEBUG > 0

#ifdef __STDC__
extern void check_same_root(int, char *);
extern void check_in_out_tbl(int, char *);
extern void check_sort_tbl(int, char *);
extern void check_weight(int, char *);
extern void check_primary_idx(int, char *);
#else
extern void check_same_root(/*int, char **/);
extern void check_in_out_tbl(/*int, char **/);
extern void check_sort_tbl(/*int, char**/);
extern void check_weight(/*int, char **/);
extern void check_primary_idx(/*int, char **/);
#endif/* __STDC__ */

#endif/* DEBUG > 0 */

/*>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<*/

#if VERBOSE > 0

#ifdef __STDC__
extern void print_input_tbl(int, char *, int);
extern void print_all_input_tbl(int, char *);
extern void print_output_tbl(int, char *, int);
extern void print_all_output_tbl(int, char *);
extern void print_syntax_node(int, char *, syntax_t *);
extern void print_syntax_tree(int, char *, syntax_t *);
extern void print_primary_out_tbl(int, char *);
extern void print_sort_tbl(int, char *);
#else
extern void print_input_tbl(/*int, char *, int*/);
extern void print_all_input_tbl(/*int, char **/);
extern void print_output_tbl(/*int, char *, int*/);
extern void print_all_output_tbl(/*int, char **/);
extern void print_syntax_node(/*int, char *, syntax_t **/);
extern void print_syntax_tree(/*int, char *, syntax_t **/);
extern void print_primary_out_tbl(/*int, char **/);
extern void print_sort_tbl(/*int, char **/);
#endif/* __STDC__ */

#endif/* VERBOSE > 0 */

/*>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<*/

#if DEBUG > 0
#define ROOT_CHECK					check_same_root(__LINE__, __FILE__)
#define VAR_CHECK					check_in_out_tbl(__LINE__, __FILE__)
#define SORT_CHECK					check_sort_tbl(__LINE__, __FILE__)
#define WEIGHT_CHECK				check_weight(__LINE__, __FILE__)
#define PRIMARY_CHECK				check_primary_idx(__LINE__, __FILE__)
#define UNUSED_INPUT_CHECK(idx)		check_unused_input(__LINE__, __FILE__, idx)
#define USED_INPUT_CHECK			check_used_input(__LINE__, __FILE__)
#define ORDER_TBL_CHECK				check_order_tbl(__LINE__, __FILE__)
#else
#define ROOT_CHECK
#define VAR_CHECK
#define SORT_CHECK
#define WEIGHT_CHECK
#define PRIMARY_CHECK
#define UNUSED_INPUT_CHECK(idx)
#define USED_INPUT_CHECK
#define ORDER_TBL_CHECK
#endif/* DEBUG > 0 */

/*>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<*/

#if VERBOSE > 8
#define PRINT_INPUT_TBL9(idx)		print_input_tbl(__LINE__, __FILE__, idx)
#define PRINT_ALL_INPUT_TBL9		print_all_input_tbl(__LINE__, __FILE__)
#define PRINT_OUTPUT_TBL9(idx)		print_output_tbl(__LINE__, __FILE__, idx)
#define PRINT_ALL_OUTPUT_TBL9		print_all_output_tbl(__LINE__, __FILE__)
#define PRINT_SYNTAX_NODE9(root)	print_syntax_node(__LINE__, __FILE__, root)
#define PRINT_SYNTAX_TREE9(root)	print_syntax_tree(__LINE__, __FILE__, root)
#define PRINT_PRIMARY_OUT9			print_primary_out_tbl(__LINE__, __FILE__)
#define PRINT_SORT_TBL9				print_sort_tbl(__LINE__, __FILE__)
#define PRINT_ALL_ORDER_TBL9		print_all_order_tbl(__LINE__, __FILE__)
#else
#define PRINT_INPUT_TBL9(idx)		
#define PRINT_ALL_INPUT_TBL9		
#define PRINT_OUTPUT_TBL9(idx)		
#define PRINT_ALL_OUTPUT_TBL9
#define PRINT_SYNTAX_NODE9(root)
#define PRINT_SYNTAX_TREE9(root)
#define PRINT_PRIMARY_OUT9
#define PRINT_SORT_TBL9
#define PRINT_ALL_ORDER_TBL9		
#endif/* VERBOSE > 8 */

#if VERBOSE > 9
#define PRINT_INPUT_TBL10(idx)		print_input_tbl(__LINE__, __FILE__, idx)
#define PRINT_ALL_INPUT_TBL10		print_all_input_tbl(__LINE__, __FILE__)
#define PRINT_OUTPUT_TBL10(idx)		print_output_tbl(__LINE__, __FILE__, idx)
#define PRINT_ALL_OUTPUT_TBL10		print_all_output_tbl(__LINE__, __FILE__)
#define PRINT_SYNTAX_NODE10(root)	print_syntax_node(__LINE__, __FILE__, root)
#define PRINT_SYNTAX_TREE10(root)	print_syntax_tree(__LINE__, __FILE__, root)
#define PRINT_PRIMARY_OUT10			print_primary_out_tbl(__LINE__, __FILE__)
#define PRINT_SORT_TBL10			print_sort_tbl(__LINE__, __FILE__)
#else
#define PRINT_INPUT_TBL10(idx)		
#define PRINT_ALL_INPUT_TBL10		
#define PRINT_OUTPUT_TBL10(idx)		
#define PRINT_ALL_OUTPUT_TBL10
#define PRINT_SYNTAX_NODE10(root)
#define PRINT_SYNTAX_TREE10(root)
#define PRINT_PRIMARY_OUT10
#define PRINT_SORT_TBL10
#endif/* VERBOSE > 9 */

/* ---------- end of file 'debug.c' ---------- */
